﻿# 
#   ______                           __        ____    _      __  __     
#  / ___(_)__ ___ _  ___  ___ ____  / /__     / __/___(_)_ __/ /_/ /____ 
# / (_ / / _ `/  ' \/ _ \/ _ `/ _ \/ / _ \   _\ \/ __/ / // / __/ __/ _ \
# \___/_/\_,_/_/_/_/ .__/\_,_/\___/_/\___/  /___/\__/_/\_,_/\__/\__/\___/
#                 /_/                                                   
# http://www.giampaolo-sciutto.it/

# Name Script : ADD_User_to_Group_from_CSV_File.ps1
# Descrizione : Sposta X utenti AD all'interno di un gruppo AD tramite un file .csv
# 
# Versione    : 1.0
# Requisiti   : Import-Module ActiveDirectory
# Piattaforme Verificate : Windows 2012/2008R2
#
# Modify by Giampaolo Sciutto
# Date Modify: 24/11/2016
#

<#
$objUser.CN                   --> TAB GENERALE / etichetta: prima info in alto a sx

$objUser.GivenName                  --> TAB GENERALE / Nome
$objUser.Surname                    --> TAB GENERALE / Cognome
$objUser.displayname                --> TAB GENERALE / Nome Visualizzato
$objUser.Description                --> TAB GENERALE / Descrizione
$objUser.physicalDeliveryOfficeName --> TAB GENERALE / Ufficio
$objUser.mail                       --> TAB GENERALE / Posta Elettronica

$objUser.name               --> TAB ACCOUNT / Nome Accesso Utente
$objUser.SamAccountName     --> TAB ACCOUNT / Nome Accesso Utente (precedente a Win 2000)
#>

import-module activedirectory

### Definizione costanti
$ErrorLog     = "NotFound.log"
$INPUTListCSV = "lista.csv" 
$OUTListCSV   = "OUT.log"

### Carico info dal CSV
$csv = @()  
$csv = Import-Csv -Delimiter ";" -Path $INPUTListCSV

### CHECK su ogni riga
ForEach ($riga In $csv)  
{  
   # TEST # $cognome = "Sciutto" ; $nome = "Giampaolo"  
   $nome = $riga.Userid.Trim()
   # $cognome = $riga.Cognome.Trim()
   # $CommonNameLike = "*" + $cognome + "*"

   ### get utenti 
   # $objUsers = get-aduser -f {cn -like "test*" } -property *  | Where {$_.Enabled -eq $true} |select-object –property Name, GivenName, SamAccountName 
   $objUsers = get-aduser -f {SamAccountName -eq $nome } -property * 
   # $objUsers = get-aduser -f {CN -like $CommonNameLike -OR Surname -like $CommonNameLike } -Properties * |select-object –property CN, Name, GivenName, SamAccountName, Enabled
   
   IF ($objUsers.count -eq 0)
   {
      "-------------------------------------------------------------" | Out-File -append $ErrorLog
      "$nome - NOT FOUND as (like) Common Name OR Surname." | Out-File -append $ErrorLog
      Write-Host -f RED "$nome - NOT FOUND as (like) Common Name OR Surname." 
   }
   ELSE
   {
      $Error.Clear()
      Add-ADPrincipalGroupMembership -Identity $nome -MemberOf "NOME GRUPPO AD"
      IF ($Error[0])
      {
         Add-Content $ErrorLog "ERRORE in fase di Add-ADPrincipalGroupMembership SAM: $nome"
         Add-Content $ErrorLog $Error[0] 
         Write-Host -F RED    $Error[0]
         # Remove-PSSession $s
         RETURN
      }
      Write-Host -f GREEN $nome
      $nome | out-file -append $OUTListCSV
   }
}


